<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Neo4J.Queries</span><span>
</span><span id="line-2"></span><span>  </span><span class="hs-special">(</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#getNodes"><span class="hs-identifier">getNodes</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-3"></span><span>    </span><span class="annot"><a href="Neo4J.Queries.html#getNodePair"><span class="hs-identifier">getNodePair</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-4"></span><span>    </span><span class="annot"><a href="Neo4J.Queries.html#anthroponymsQ"><span class="hs-identifier">anthroponymsQ</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-5"></span><span>    </span><span class="annot"><a href="Neo4J.Queries.html#occupationsQ"><span class="hs-identifier">occupationsQ</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-6"></span><span>    </span><span class="annot"><a href="Neo4J.Queries.html#personIntensiveQ"><span class="hs-identifier">personIntensiveQ</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-7"></span><span>    </span><span class="annot"><a href="Neo4J.Queries.html#norNorkVerbsQ"><span class="hs-identifier">norNorkVerbsQ</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-8"></span><span>    </span><span class="annot"><a href="Neo4J.Queries.html#possessionQ"><span class="hs-identifier">possessionQ</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-9"></span><span>  </span><span class="hs-special">)</span><span>
</span><span id="line-10"></span><span class="hs-keyword">where</span><span>
</span><span id="line-11"></span><span>
</span><span id="line-12"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Applicative</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">liftA2</span></span><span class="hs-special">)</span><span>
</span><span id="line-13"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Control.Monad</span></span><span>
</span><span id="line-14"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Data.List</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">intersperse</span></span><span class="hs-special">)</span><span>
</span><span id="line-15"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Map</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">M</span></span><span>
</span><span id="line-16"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Text</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">T</span></span><span>
</span><span id="line-17"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><span class="hs-identifier">Database.Bolt</span></span><span>
</span><span id="line-18"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="EuskeraAppError.html"><span class="hs-identifier">EuskeraAppError</span></a></span><span>
</span><span id="line-19"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Lexis.html"><span class="hs-identifier">Lexis</span></a></span><span>
</span><span id="line-20"></span><span class="hs-keyword">import</span><span> </span><span class="annot"><a href="Neo4J.Conversion.html"><span class="hs-identifier">Neo4J.Conversion</span></a></span><span>
</span><span id="line-21"></span><span>
</span><span id="line-22"></span><span class="hs-keyword">type</span><span> </span><span id="NodeRef"><span class="annot"><a href="Neo4J.Queries.html#NodeRef"><span class="hs-identifier hs-var">NodeRef</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-23"></span><span>
</span><span id="line-24"></span><span class="hs-keyword">type</span><span> </span><span id="CypherQuery"><span class="annot"><a href="Neo4J.Queries.html#CypherQuery"><span class="hs-identifier hs-var">CypherQuery</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="hs-identifier hs-type">String</span></span><span>
</span><span id="line-25"></span><span>
</span><span id="line-26"></span><span class="hs-comment">-- | Get all individual nodes matching a query and create Lexis elements</span><span>
</span><span id="line-27"></span><span class="annot"><a href="Neo4J.Queries.html#getNodes"><span class="hs-identifier hs-type">getNodes</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-28"></span><span>  </span><span class="hs-special">(</span><span class="annot"><a href="Neo4J.Queries.html#NodeRef"><span class="hs-identifier hs-type">NodeRef</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#CypherQuery"><span class="hs-identifier hs-type">CypherQuery</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-29"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">BoltActionT</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-30"></span><span id="getNodes"><span class="annot"><span class="annottext">getNodes :: (NodeRef -&gt; NodeRef)
-&gt; BoltActionT IO [Either EuskeraAppError Lexis]
</span><a href="Neo4J.Queries.html#getNodes"><span class="hs-identifier hs-var hs-var">getNodes</span></a></span></span><span> </span><span id="local-6989586621679082658"><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef
</span><a href="#local-6989586621679082658"><span class="hs-identifier hs-var">qry</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-31"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span id="local-6989586621679082657"><span class="annot"><span class="annottext">nodeRef :: NodeRef
</span><a href="#local-6989586621679082657"><span class="hs-identifier hs-var hs-var">nodeRef</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;n&quot;</span></span><span>
</span><span id="line-32"></span><span>  </span><span id="local-6989586621679082656"><span class="annot"><span class="annottext">[Record]
</span><a href="#local-6989586621679082656"><span class="hs-identifier hs-var">records</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">Text -&gt; BoltActionT IO [Record]
forall (m :: * -&gt; *).
(MonadIO m, HasCallStack) =&gt;
Text -&gt; BoltActionT m [Record]
</span><span class="hs-identifier hs-var">query</span></span><span> </span><span class="annot"><span class="annottext">(Text -&gt; BoltActionT IO [Record])
-&gt; Text -&gt; BoltActionT IO [Record]
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">NodeRef -&gt; Text
</span><span class="hs-identifier hs-var">T.pack</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef
</span><a href="#local-6989586621679082658"><span class="hs-identifier hs-var">qry</span></a></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082657"><span class="hs-identifier hs-var">nodeRef</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-33"></span><span>  </span><span class="annot"><span class="annottext">[Record]
-&gt; (Record -&gt; BoltActionT IO (Either EuskeraAppError Lexis))
-&gt; BoltActionT IO [Either EuskeraAppError Lexis]
forall (t :: * -&gt; *) (m :: * -&gt; *) a b.
(Traversable t, Monad m) =&gt;
t a -&gt; (a -&gt; m b) -&gt; m (t b)
</span><span class="hs-identifier hs-var">forM</span></span><span> </span><span class="annot"><span class="annottext">[Record]
</span><a href="#local-6989586621679082656"><span class="hs-identifier hs-var">records</span></a></span><span> </span><span class="annot"><span class="annottext">((Record -&gt; BoltActionT IO (Either EuskeraAppError Lexis))
 -&gt; BoltActionT IO [Either EuskeraAppError Lexis])
-&gt; (Record -&gt; BoltActionT IO (Either EuskeraAppError Lexis))
-&gt; BoltActionT IO [Either EuskeraAppError Lexis]
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679082652"><span class="annot"><span class="annottext">Record
</span><a href="#local-6989586621679082652"><span class="hs-identifier hs-var">record</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-34"></span><span>    </span><span class="annot"><span class="annottext">Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.html#nodeToLexis"><span class="hs-identifier hs-var">nodeToLexis</span></a></span><span>
</span><span id="line-35"></span><span>      </span><span class="annot"><span class="annottext">(Node -&gt; Either EuskeraAppError Lexis)
-&gt; BoltActionT IO Node
-&gt; BoltActionT IO (Either EuskeraAppError Lexis)
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Record
</span><a href="#local-6989586621679082652"><span class="hs-identifier hs-var">record</span></a></span><span> </span><span class="annot"><span class="annottext">Record -&gt; Text -&gt; BoltActionT IO Node
forall (m :: * -&gt; *) a.
(Monad m, RecordValue a) =&gt;
Record -&gt; Text -&gt; BoltActionT m a
</span><span class="hs-operator hs-var">`at`</span></span><span> </span><span class="annot"><span class="annottext">NodeRef -&gt; Text
</span><span class="hs-identifier hs-var">T.pack</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082657"><span class="hs-identifier hs-var">nodeRef</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-36"></span><span>
</span><span id="line-37"></span><span class="hs-comment">-- | Create pairs of Lexis elements from query</span><span>
</span><span id="line-38"></span><span class="annot"><a href="Neo4J.Queries.html#getNodePair"><span class="hs-identifier hs-type">getNodePair</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-39"></span><span>  </span><span class="hs-special">(</span><span class="hs-special">[</span><span class="annot"><a href="Neo4J.Queries.html#NodeRef"><span class="hs-identifier hs-type">NodeRef</span></a></span><span class="hs-special">]</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#CypherQuery"><span class="hs-identifier hs-type">CypherQuery</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-40"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">BoltActionT</span></span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="Lexis.html#Lexis"><span class="hs-identifier hs-type">Lexis</span></a></span><span class="hs-special">)</span><span class="hs-special">]</span><span>
</span><span id="line-41"></span><span id="getNodePair"><span class="annot"><span class="annottext">getNodePair :: ([NodeRef] -&gt; NodeRef)
-&gt; BoltActionT IO [Either EuskeraAppError (Lexis, Lexis)]
</span><a href="Neo4J.Queries.html#getNodePair"><span class="hs-identifier hs-var hs-var">getNodePair</span></a></span></span><span> </span><span id="local-6989586621679082648"><span class="annot"><span class="annottext">[NodeRef] -&gt; NodeRef
</span><a href="#local-6989586621679082648"><span class="hs-identifier hs-var">qry</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-42"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span id="local-6989586621679082647"><span class="annot"><span class="annottext">ref1 :: NodeRef
</span><a href="#local-6989586621679082647"><span class="hs-identifier hs-var hs-var">ref1</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;r1&quot;</span></span><span>
</span><span id="line-43"></span><span>  </span><span class="hs-keyword">let</span><span> </span><span id="local-6989586621679082646"><span class="annot"><span class="annottext">ref2 :: NodeRef
</span><a href="#local-6989586621679082646"><span class="hs-identifier hs-var hs-var">ref2</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;r2&quot;</span></span><span>
</span><span id="line-44"></span><span>  </span><span id="local-6989586621679082645"><span class="annot"><span class="annottext">[Record]
</span><a href="#local-6989586621679082645"><span class="hs-identifier hs-var">records</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">Text -&gt; BoltActionT IO [Record]
forall (m :: * -&gt; *).
(MonadIO m, HasCallStack) =&gt;
Text -&gt; BoltActionT m [Record]
</span><span class="hs-identifier hs-var">query</span></span><span> </span><span class="annot"><span class="annottext">(Text -&gt; BoltActionT IO [Record])
-&gt; Text -&gt; BoltActionT IO [Record]
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">NodeRef -&gt; Text
</span><span class="hs-identifier hs-var">T.pack</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">[NodeRef] -&gt; NodeRef
</span><a href="#local-6989586621679082648"><span class="hs-identifier hs-var">qry</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082647"><span class="hs-identifier hs-var">ref1</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082646"><span class="hs-identifier hs-var">ref2</span></a></span><span class="hs-special">]</span><span class="hs-special">)</span><span>
</span><span id="line-45"></span><span>  </span><span id="local-6989586621679082644"><span class="annot"><span class="annottext">[Either EuskeraAppError Lexis]
</span><a href="#local-6989586621679082644"><span class="hs-identifier hs-var">firsts</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">[Record]
-&gt; (Record -&gt; BoltActionT IO (Either EuskeraAppError Lexis))
-&gt; BoltActionT IO [Either EuskeraAppError Lexis]
forall (t :: * -&gt; *) (m :: * -&gt; *) a b.
(Traversable t, Monad m) =&gt;
t a -&gt; (a -&gt; m b) -&gt; m (t b)
</span><span class="hs-identifier hs-var">forM</span></span><span> </span><span class="annot"><span class="annottext">[Record]
</span><a href="#local-6989586621679082645"><span class="hs-identifier hs-var">records</span></a></span><span> </span><span class="annot"><span class="annottext">((Record -&gt; BoltActionT IO (Either EuskeraAppError Lexis))
 -&gt; BoltActionT IO [Either EuskeraAppError Lexis])
-&gt; (Record -&gt; BoltActionT IO (Either EuskeraAppError Lexis))
-&gt; BoltActionT IO [Either EuskeraAppError Lexis]
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679082643"><span class="annot"><span class="annottext">Record
</span><a href="#local-6989586621679082643"><span class="hs-identifier hs-var">record</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-46"></span><span>    </span><span class="annot"><span class="annottext">Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.html#nodeToLexis"><span class="hs-identifier hs-var">nodeToLexis</span></a></span><span> </span><span class="annot"><span class="annottext">(Node -&gt; Either EuskeraAppError Lexis)
-&gt; BoltActionT IO Node
-&gt; BoltActionT IO (Either EuskeraAppError Lexis)
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">Record
</span><a href="#local-6989586621679082643"><span class="hs-identifier hs-var">record</span></a></span><span> </span><span class="annot"><span class="annottext">Record -&gt; Text -&gt; BoltActionT IO Node
forall (m :: * -&gt; *) a.
(Monad m, RecordValue a) =&gt;
Record -&gt; Text -&gt; BoltActionT m a
</span><span class="hs-operator hs-var">`at`</span></span><span> </span><span class="annot"><span class="annottext">NodeRef -&gt; Text
</span><span class="hs-identifier hs-var">T.pack</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082647"><span class="hs-identifier hs-var">ref1</span></a></span><span>
</span><span id="line-47"></span><span>  </span><span id="local-6989586621679082642"><span class="annot"><span class="annottext">[Either EuskeraAppError Lexis]
</span><a href="#local-6989586621679082642"><span class="hs-identifier hs-var">seconds</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">[Record]
-&gt; (Record -&gt; BoltActionT IO (Either EuskeraAppError Lexis))
-&gt; BoltActionT IO [Either EuskeraAppError Lexis]
forall (t :: * -&gt; *) (m :: * -&gt; *) a b.
(Traversable t, Monad m) =&gt;
t a -&gt; (a -&gt; m b) -&gt; m (t b)
</span><span class="hs-identifier hs-var">forM</span></span><span> </span><span class="annot"><span class="annottext">[Record]
</span><a href="#local-6989586621679082645"><span class="hs-identifier hs-var">records</span></a></span><span> </span><span class="annot"><span class="annottext">((Record -&gt; BoltActionT IO (Either EuskeraAppError Lexis))
 -&gt; BoltActionT IO [Either EuskeraAppError Lexis])
-&gt; (Record -&gt; BoltActionT IO (Either EuskeraAppError Lexis))
-&gt; BoltActionT IO [Either EuskeraAppError Lexis]
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679082641"><span class="annot"><span class="annottext">Record
</span><a href="#local-6989586621679082641"><span class="hs-identifier hs-var">record</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-48"></span><span>    </span><span class="annot"><span class="annottext">Node -&gt; Either EuskeraAppError Lexis
</span><a href="Neo4J.Conversion.html#nodeToLexis"><span class="hs-identifier hs-var">nodeToLexis</span></a></span><span> </span><span class="annot"><span class="annottext">(Node -&gt; Either EuskeraAppError Lexis)
-&gt; BoltActionT IO Node
-&gt; BoltActionT IO (Either EuskeraAppError Lexis)
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="annot"><span class="annottext">Record
</span><a href="#local-6989586621679082641"><span class="hs-identifier hs-var">record</span></a></span><span> </span><span class="annot"><span class="annottext">Record -&gt; Text -&gt; BoltActionT IO Node
forall (m :: * -&gt; *) a.
(Monad m, RecordValue a) =&gt;
Record -&gt; Text -&gt; BoltActionT m a
</span><span class="hs-operator hs-var">`at`</span></span><span> </span><span class="annot"><span class="annottext">NodeRef -&gt; Text
</span><span class="hs-identifier hs-var">T.pack</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082646"><span class="hs-identifier hs-var">ref2</span></a></span><span>
</span><span id="line-49"></span><span>  </span><span class="annot"><span class="annottext">[Either EuskeraAppError (Lexis, Lexis)]
-&gt; BoltActionT IO [Either EuskeraAppError (Lexis, Lexis)]
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">([Either EuskeraAppError (Lexis, Lexis)]
 -&gt; BoltActionT IO [Either EuskeraAppError (Lexis, Lexis)])
-&gt; [Either EuskeraAppError (Lexis, Lexis)]
-&gt; BoltActionT IO [Either EuskeraAppError (Lexis, Lexis)]
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">(Either EuskeraAppError Lexis
 -&gt; Either EuskeraAppError Lexis
 -&gt; Either EuskeraAppError (Lexis, Lexis))
-&gt; [Either EuskeraAppError Lexis]
-&gt; [Either EuskeraAppError Lexis]
-&gt; [Either EuskeraAppError (Lexis, Lexis)]
forall a b c. (a -&gt; b -&gt; c) -&gt; [a] -&gt; [b] -&gt; [c]
</span><span class="hs-identifier hs-var">zipWith</span></span><span> </span><span class="annot"><span class="annottext">Either EuskeraAppError Lexis
-&gt; Either EuskeraAppError Lexis
-&gt; Either EuskeraAppError (Lexis, Lexis)
forall a b.
Either EuskeraAppError a
-&gt; Either EuskeraAppError b -&gt; Either EuskeraAppError (a, b)
</span><a href="Neo4J.Queries.html#makePair"><span class="hs-identifier hs-var">makePair</span></a></span><span> </span><span class="annot"><span class="annottext">[Either EuskeraAppError Lexis]
</span><a href="#local-6989586621679082644"><span class="hs-identifier hs-var">firsts</span></a></span><span> </span><span class="annot"><span class="annottext">[Either EuskeraAppError Lexis]
</span><a href="#local-6989586621679082642"><span class="hs-identifier hs-var">seconds</span></a></span><span>
</span><span id="line-50"></span><span>
</span><span id="line-51"></span><span id="local-6989586621679082675"><span id="local-6989586621679082676"><span class="annot"><a href="Neo4J.Queries.html#makePair"><span class="hs-identifier hs-type">makePair</span></a></span><span> </span><span class="hs-glyph">::</span><span>
</span><span id="line-52"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679082676"><span class="hs-identifier hs-type">a</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-53"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679082675"><span class="hs-identifier hs-type">b</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-54"></span><span>  </span><span class="annot"><span class="hs-identifier hs-type">Either</span></span><span> </span><span class="annot"><a href="EuskeraAppError.html#EuskeraAppError"><span class="hs-identifier hs-type">EuskeraAppError</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="#local-6989586621679082676"><span class="hs-identifier hs-type">a</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><a href="#local-6989586621679082675"><span class="hs-identifier hs-type">b</span></a></span><span class="hs-special">)</span></span></span><span>
</span><span id="line-55"></span><span id="makePair"><span class="annot"><span class="annottext">makePair :: Either EuskeraAppError a
-&gt; Either EuskeraAppError b -&gt; Either EuskeraAppError (a, b)
</span><a href="Neo4J.Queries.html#makePair"><span class="hs-identifier hs-var hs-var">makePair</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Left</span></span><span> </span><span id="local-6989586621679082638"><span class="annot"><span class="annottext">EuskeraAppError
</span><a href="#local-6989586621679082638"><span class="hs-identifier hs-var">error</span></a></span></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="annottext">Either EuskeraAppError b
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">EuskeraAppError -&gt; Either EuskeraAppError (a, b)
forall a b. a -&gt; Either a b
</span><span class="hs-identifier hs-var">Left</span></span><span> </span><span class="annot"><span class="annottext">EuskeraAppError
</span><a href="#local-6989586621679082638"><span class="hs-identifier hs-var">error</span></a></span><span>
</span><span id="line-56"></span><span class="annot"><a href="Neo4J.Queries.html#makePair"><span class="hs-identifier hs-var">makePair</span></a></span><span> </span><span class="annot"><span class="annottext">Either EuskeraAppError a
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Left</span></span><span> </span><span id="local-6989586621679082637"><span class="annot"><span class="annottext">EuskeraAppError
</span><a href="#local-6989586621679082637"><span class="hs-identifier hs-var">error</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">EuskeraAppError -&gt; Either EuskeraAppError (a, b)
forall a b. a -&gt; Either a b
</span><span class="hs-identifier hs-var">Left</span></span><span> </span><span class="annot"><span class="annottext">EuskeraAppError
</span><a href="#local-6989586621679082637"><span class="hs-identifier hs-var">error</span></a></span><span>
</span><span id="line-57"></span><span class="annot"><a href="Neo4J.Queries.html#makePair"><span class="hs-identifier hs-var">makePair</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Right</span></span><span> </span><span id="local-6989586621679082636"><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679082636"><span class="hs-identifier hs-var">a</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Right</span></span><span> </span><span id="local-6989586621679082635"><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679082635"><span class="hs-identifier hs-var">b</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">(a, b) -&gt; Either EuskeraAppError (a, b)
forall a b. b -&gt; Either a b
</span><span class="hs-identifier hs-var">Right</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">a
</span><a href="#local-6989586621679082636"><span class="hs-identifier hs-var">a</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">b
</span><a href="#local-6989586621679082635"><span class="hs-identifier hs-var">b</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-58"></span><span>
</span><span id="line-59"></span><span class="hs-comment">-- | Query to retrieve all person names</span><span>
</span><span id="line-60"></span><span class="annot"><a href="Neo4J.Queries.html#anthroponymsQ"><span class="hs-identifier hs-type">anthroponymsQ</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#NodeRef"><span class="hs-identifier hs-type">NodeRef</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#CypherQuery"><span class="hs-identifier hs-type">CypherQuery</span></a></span><span>
</span><span id="line-61"></span><span id="anthroponymsQ"><span class="annot"><span class="annottext">anthroponymsQ :: NodeRef -&gt; NodeRef
</span><a href="Neo4J.Queries.html#anthroponymsQ"><span class="hs-identifier hs-var hs-var">anthroponymsQ</span></a></span></span><span> </span><span id="local-6989586621679082634"><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082634"><span class="hs-identifier hs-var">nodeRef</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-62"></span><span>  </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
</span><a href="Neo4J.Queries.html#randomizeQueryResults"><span class="hs-identifier hs-var">randomizeQueryResults</span></a></span><span>
</span><span id="line-63"></span><span>    </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082634"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-64"></span><span>    </span><span class="hs-special">(</span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;MATCH (&quot;</span></span><span>
</span><span id="line-65"></span><span>        </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082634"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-66"></span><span>        </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;:Anthroponym)&quot;</span></span><span>
</span><span id="line-67"></span><span>    </span><span class="hs-special">)</span><span>
</span><span id="line-68"></span><span>
</span><span id="line-69"></span><span class="hs-comment">-- | Query to retrieve all jobs associated to a person</span><span>
</span><span id="line-70"></span><span class="annot"><a href="Neo4J.Queries.html#occupationsQ"><span class="hs-identifier hs-type">occupationsQ</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#NodeRef"><span class="hs-identifier hs-type">NodeRef</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#CypherQuery"><span class="hs-identifier hs-type">CypherQuery</span></a></span><span>
</span><span id="line-71"></span><span id="occupationsQ"><span class="annot"><span class="annottext">occupationsQ :: NodeRef -&gt; NodeRef
</span><a href="Neo4J.Queries.html#occupationsQ"><span class="hs-identifier hs-var hs-var">occupationsQ</span></a></span></span><span> </span><span id="local-6989586621679082632"><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082632"><span class="hs-identifier hs-var">nodeRef</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-72"></span><span>  </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
</span><a href="Neo4J.Queries.html#randomizeQueryResults"><span class="hs-identifier hs-var">randomizeQueryResults</span></a></span><span>
</span><span id="line-73"></span><span>    </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082632"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-74"></span><span>    </span><span class="hs-special">(</span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;MATCH (:Occupation)&lt;-[:IDENTITY]-(&quot;</span></span><span>
</span><span id="line-75"></span><span>        </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082632"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-76"></span><span>        </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;:Noun)&lt;-[:CLASS_ASCRIPTION]-(:Person)&quot;</span></span><span>
</span><span id="line-77"></span><span>    </span><span class="hs-special">)</span><span>
</span><span id="line-78"></span><span>
</span><span id="line-79"></span><span class="hs-comment">-- | Query to retrieve all verb-object pairs where the object is the nor argument</span><span>
</span><span id="line-80"></span><span class="hs-comment">-- of the verb, in random order.</span><span>
</span><span id="line-81"></span><span class="annot"><a href="Neo4J.Queries.html#norNorkVerbsQ"><span class="hs-identifier hs-type">norNorkVerbsQ</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="hs-special">[</span><span class="annot"><a href="Neo4J.Queries.html#NodeRef"><span class="hs-identifier hs-type">NodeRef</span></a></span><span class="hs-special">]</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#CypherQuery"><span class="hs-identifier hs-type">CypherQuery</span></a></span><span>
</span><span id="line-82"></span><span id="norNorkVerbsQ"><span class="annot"><span class="annottext">norNorkVerbsQ :: [NodeRef] -&gt; NodeRef
</span><a href="Neo4J.Queries.html#norNorkVerbsQ"><span class="hs-identifier hs-var hs-var">norNorkVerbsQ</span></a></span></span><span> </span><span class="hs-special">[</span><span id="local-6989586621679082631"><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082631"><span class="hs-identifier hs-var">vRef</span></a></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679082630"><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082630"><span class="hs-identifier hs-var">nRef</span></a></span></span><span class="hs-special">]</span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-83"></span><span>  </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;match (&quot;</span></span><span>
</span><span id="line-84"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082631"><span class="hs-identifier hs-var">vRef</span></a></span><span>
</span><span id="line-85"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;:NorNork)-[:NOR]-&gt;(:Category)&lt;-[:IDENTITY*0..]-(:Category)&lt;-[:IDENTITY]-(&quot;</span></span><span>
</span><span id="line-86"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082630"><span class="hs-identifier hs-var">nRef</span></a></span><span>
</span><span id="line-87"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;:Noun) &quot;</span></span><span>
</span><span id="line-88"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;with &quot;</span></span><span>
</span><span id="line-89"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082631"><span class="hs-identifier hs-var">vRef</span></a></span><span>
</span><span id="line-90"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, &quot;</span></span><span>
</span><span id="line-91"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082630"><span class="hs-identifier hs-var">nRef</span></a></span><span>
</span><span id="line-92"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, &quot;</span></span><span>
</span><span id="line-93"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;rand() as r with &quot;</span></span><span>
</span><span id="line-94"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082631"><span class="hs-identifier hs-var">vRef</span></a></span><span>
</span><span id="line-95"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, &quot;</span></span><span>
</span><span id="line-96"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082630"><span class="hs-identifier hs-var">nRef</span></a></span><span>
</span><span id="line-97"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, &quot;</span></span><span>
</span><span id="line-98"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;apoc.util.md5([id(&quot;</span></span><span>
</span><span id="line-99"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082631"><span class="hs-identifier hs-var">vRef</span></a></span><span>
</span><span id="line-100"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;), id(&quot;</span></span><span>
</span><span id="line-101"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082630"><span class="hs-identifier hs-var">nRef</span></a></span><span>
</span><span id="line-102"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;), r]) as hash &quot;</span></span><span>
</span><span id="line-103"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;return &quot;</span></span><span>
</span><span id="line-104"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082631"><span class="hs-identifier hs-var">vRef</span></a></span><span>
</span><span id="line-105"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, &quot;</span></span><span>
</span><span id="line-106"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082630"><span class="hs-identifier hs-var">nRef</span></a></span><span>
</span><span id="line-107"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot; order by hash&quot;</span></span><span>
</span><span id="line-108"></span><span>
</span><span id="line-109"></span><span class="hs-comment">-- Query to retrieve all the nodes related to the category Person by the</span><span>
</span><span id="line-110"></span><span class="hs-comment">-- relationship INTENSIVE</span><span>
</span><span id="line-111"></span><span class="annot"><a href="Neo4J.Queries.html#personIntensiveQ"><span class="hs-identifier hs-type">personIntensiveQ</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#NodeRef"><span class="hs-identifier hs-type">NodeRef</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#CypherQuery"><span class="hs-identifier hs-type">CypherQuery</span></a></span><span>
</span><span id="line-112"></span><span id="personIntensiveQ"><span class="annot"><span class="annottext">personIntensiveQ :: NodeRef -&gt; NodeRef
</span><a href="Neo4J.Queries.html#personIntensiveQ"><span class="hs-identifier hs-var hs-var">personIntensiveQ</span></a></span></span><span> </span><span id="local-6989586621679082629"><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082629"><span class="hs-identifier hs-var">nodeRef</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-113"></span><span>  </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;call {match (:Person)-[:INTENSIVE]-&gt;(&quot;</span></span><span> </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082629"><span class="hs-identifier hs-var">nodeRef</span></a></span><span> </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;) &quot;</span></span><span>
</span><span id="line-114"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;with &quot;</span></span><span>
</span><span id="line-115"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082629"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-116"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, rand() as r return &quot;</span></span><span>
</span><span id="line-117"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082629"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-118"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, r &quot;</span></span><span>
</span><span id="line-119"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;union all &quot;</span></span><span>
</span><span id="line-120"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot; match (:Person)&lt;-[:IDENTITY]-()-[:INTENSIVE]-(&quot;</span></span><span>
</span><span id="line-121"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082629"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-122"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;) &quot;</span></span><span>
</span><span id="line-123"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot; with &quot;</span></span><span>
</span><span id="line-124"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082629"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-125"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, rand() as r return &quot;</span></span><span>
</span><span id="line-126"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082629"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-127"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, r} return &quot;</span></span><span>
</span><span id="line-128"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082629"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-129"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot; order by r&quot;</span></span><span>
</span><span id="line-130"></span><span>
</span><span id="line-131"></span><span class="hs-comment">-- | Query to retrieve all objects that can be possessed</span><span>
</span><span id="line-132"></span><span class="hs-comment">-- by a person</span><span>
</span><span id="line-133"></span><span class="annot"><a href="Neo4J.Queries.html#possessionQ"><span class="hs-identifier hs-type">possessionQ</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#NodeRef"><span class="hs-identifier hs-type">NodeRef</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#CypherQuery"><span class="hs-identifier hs-type">CypherQuery</span></a></span><span>
</span><span id="line-134"></span><span id="possessionQ"><span class="annot"><span class="annottext">possessionQ :: NodeRef -&gt; NodeRef
</span><a href="Neo4J.Queries.html#possessionQ"><span class="hs-identifier hs-var hs-var">possessionQ</span></a></span></span><span> </span><span id="local-6989586621679082628"><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082628"><span class="hs-identifier hs-var">nodeRef</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-135"></span><span>  </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;match (:Person)-[:OWNERSHIP]-&gt;(:Category)&lt;-[:IDENTITY*0..]-(&quot;</span></span><span>
</span><span id="line-136"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082628"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-137"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;:Common) &quot;</span></span><span>
</span><span id="line-138"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;with &quot;</span></span><span>
</span><span id="line-139"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082628"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-140"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, &quot;</span></span><span>
</span><span id="line-141"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;rand() as r with &quot;</span></span><span>
</span><span id="line-142"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082628"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-143"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, &quot;</span></span><span>
</span><span id="line-144"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;apoc.util.md5([id(&quot;</span></span><span>
</span><span id="line-145"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082628"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-146"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;), r]) as hash &quot;</span></span><span>
</span><span id="line-147"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;return &quot;</span></span><span>
</span><span id="line-148"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082628"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-149"></span><span>    </span><span class="annot"><span class="annottext">NodeRef -&gt; NodeRef -&gt; NodeRef
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot; order by hash&quot;</span></span><span>
</span><span id="line-150"></span><span>
</span><span id="line-151"></span><span class="hs-comment">-- | Given a MATCH expression, provides query results in random order</span><span>
</span><span id="line-152"></span><span class="hs-comment">-- | Only works for queries that retrieve nodes from just 1 category</span><span>
</span><span id="line-153"></span><span class="annot"><a href="Neo4J.Queries.html#randomizeQueryResults"><span class="hs-identifier hs-type">randomizeQueryResults</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#NodeRef"><span class="hs-identifier hs-type">NodeRef</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#CypherQuery"><span class="hs-identifier hs-type">CypherQuery</span></a></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Neo4J.Queries.html#CypherQuery"><span class="hs-identifier hs-type">CypherQuery</span></a></span><span>
</span><span id="line-154"></span><span id="randomizeQueryResults"><span class="annot"><span class="annottext">randomizeQueryResults :: NodeRef -&gt; NodeRef -&gt; NodeRef
</span><a href="Neo4J.Queries.html#randomizeQueryResults"><span class="hs-identifier hs-var hs-var">randomizeQueryResults</span></a></span></span><span> </span><span id="local-6989586621679082627"><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082627"><span class="hs-identifier hs-var">nodeRef</span></a></span></span><span> </span><span id="local-6989586621679082626"><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082626"><span class="hs-identifier hs-var">query</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-155"></span><span>  </span><span class="annot"><span class="annottext">[NodeRef] -&gt; NodeRef
</span><span class="hs-identifier hs-var">unwords</span></span><span>
</span><span id="line-156"></span><span>    </span><span class="hs-special">[</span><span> </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082626"><span class="hs-identifier hs-var">query</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-157"></span><span>      </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;WITH &quot;</span></span><span class="hs-special">,</span><span>
</span><span id="line-158"></span><span>      </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082627"><span class="hs-identifier hs-var">nodeRef</span></a></span><span class="hs-special">,</span><span>
</span><span id="line-159"></span><span>      </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;, rand() as r&quot;</span></span><span class="hs-special">,</span><span>
</span><span id="line-160"></span><span>      </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;order by r&quot;</span></span><span class="hs-special">,</span><span>
</span><span id="line-161"></span><span>      </span><span class="annot"><span class="annottext">NodeRef
</span><span class="hs-string">&quot;return &quot;</span></span><span class="hs-special">,</span><span>
</span><span id="line-162"></span><span>      </span><span class="annot"><span class="annottext">NodeRef
</span><a href="#local-6989586621679082627"><span class="hs-identifier hs-var">nodeRef</span></a></span><span>
</span><span id="line-163"></span><span>    </span><span class="hs-special">]</span><span>
</span><span id="line-164"></span></pre></body></html>